/*
 * 机具库
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class PosMachinesController : BaseController
    {
        public PosMachinesController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 机具库列表

        /// <summary>
        /// 根据条件查询机具库列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(PosMachines data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询机具库列表

        /// <summary>
        /// 机具库列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(PosMachines data, string BindingStateSelect, string ActivationStateSelect, string UserIdMakerCode, string UserIdRealName, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("PosSn", "1"); //SN编号
            Fields.Add("ActivityList", "2"); //参加活动


            string condition = " and Status>-1";
            //绑定状态
            if (!string.IsNullOrEmpty(BindingStateSelect))
            {
                condition += " and BindingState=" + BindingStateSelect;
            }
            //激活状态
            if (!string.IsNullOrEmpty(ActivationStateSelect))
            {
                condition += " and ActivationState=" + ActivationStateSelect;
            }
            //所属创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //所属创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("PosMachines", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //绑定状态
                int BindingState = int.Parse(dic["BindingState"].ToString());
                if (BindingState == 0) dic["BindingState"] = "未绑定";
                if (BindingState == 1) dic["BindingState"] = "已绑定";
                //激活状态
                int ActivationState = int.Parse(dic["ActivationState"].ToString());
                if (ActivationState == 0) dic["ActivationState"] = "未激活";
                if (ActivationState == 1) dic["ActivationState"] = "已激活";
                //所属创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //产品类型
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                //参加活动
                dic["ActivityList"] = RelationClass.GetProfitObjectsActivesList(dic["ActivityList"].ToString());
                //绑定商户
                int BindMerchantId = int.Parse(function.CheckInt(dic["BindMerchantId"].ToString()));
                MerchantInfo bindmerchantid_MerchantInfo = db.MerchantInfo.FirstOrDefault(m => m.Id == BindMerchantId) ?? new MerchantInfo();
                dic["BindMerchantIdMerchantNo"] = "";
                dic["BindMerchantIdMerchantName"] = bindmerchantid_MerchantInfo.Name;
                dic.Remove("BindMerchantId");
                //机具类型
                int PosSnType = int.Parse(dic["PosSnType"].ToString());
                if (PosSnType == 0) dic["PosSnType"] = "兑换机具";
                if (PosSnType == 1) dic["PosSnType"] = "循环机具";
                //设备类型
                string DeviceType = dic["DeviceType"].ToString();
                if (DeviceType == "KysSignPos") dic["DeviceType"] = "快益刷电签POS";
                if (DeviceType == "KssSignPos") dic["DeviceType"] = "快闪刷电签POS";
                if (DeviceType == "") dic["DeviceType"] = "";

            }
            Dictionary<string, object> other = new Dictionary<string, object>();
            other.Add("TotalCount", 0);
            other.Add("KysCount99", 0);
            other.Add("KssCount99", 0);
            other.Add("KssCoun198", 0);
            other.Add("KssCount298", 0);
            obj.Add("other", other);
            return Json(obj);
        }

        #endregion

        #region 增加机具库

        /// <summary>
        /// 增加或修改机具库信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加机具库

        /// <summary>
        /// 增加或修改机具库信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(PosMachines data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("PosMachines", Fields, 0);
            AddSysLog(data.Id.ToString(), "PosMachines", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改机具库

        /// <summary>
        /// 增加或修改机具库信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            PosMachines editData = db.PosMachines.FirstOrDefault(m => m.Id == Id) ?? new PosMachines();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改机具库

        /// <summary>
        /// 增加或修改机具库信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(PosMachines data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PosMachines", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "PosMachines", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除机具库信息

        /// <summary>
        /// 删除机具库信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "PosMachines", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PosMachines", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "PosMachines", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PosMachines", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "PosMachines", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PosMachines", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("PosMachines", Sort, Id);

            AddSysLog(Id.ToString(), "PosMachines", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.PosMachines.Add(new PosMachines()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "PosMachines", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(PosMachines data, string BindingStateSelect, string ActivationStateSelect, string UserIdMakerCode, string UserIdRealName)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("PosSn", "1"); //SN编号
            Fields.Add("ActivityList", "2"); //参加活动


            string condition = " and Status>-1";
            //绑定状态
            if (!string.IsNullOrEmpty(BindingStateSelect))
            {
                condition += " and BindingState=" + BindingStateSelect;
            }
            //激活状态
            if (!string.IsNullOrEmpty(ActivationStateSelect))
            {
                condition += " and ActivationState=" + ActivationStateSelect;
            }
            //所属创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //所属创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("PosMachines", Fields, "Id desc", "0", 1, 20000, condition, "BindingState,ActivationState,UserId,PosSn,BrandId,ActivityList,BindMerchantId,PosSnType,DeviceType", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //绑定状态
                int BindingState = int.Parse(dic["BindingState"].ToString());
                if (BindingState == 0) dic["BindingState"] = "未绑定";
                if (BindingState == 1) dic["BindingState"] = "已绑定";
                //激活状态
                int ActivationState = int.Parse(dic["ActivationState"].ToString());
                if (ActivationState == 0) dic["ActivationState"] = "未激活";
                if (ActivationState == 1) dic["ActivationState"] = "已激活";
                //所属创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //产品类型
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                //参加活动
                dic["ActivityList"] = RelationClass.GetProfitObjectsActivesList(dic["ActivityList"].ToString());
                //绑定商户
                int BindMerchantId = int.Parse(function.CheckInt(dic["BindMerchantId"].ToString()));
                MerchantInfo bindmerchantid_MerchantInfo = db.MerchantInfo.FirstOrDefault(m => m.Id == BindMerchantId) ?? new MerchantInfo();
                dic["BindMerchantIdMerchantNo"] = "";
                dic["BindMerchantIdMerchantName"] = bindmerchantid_MerchantInfo.Name;
                dic.Remove("BindMerchantId");
                //机具类型
                int PosSnType = int.Parse(dic["PosSnType"].ToString());
                if (PosSnType == 0) dic["PosSnType"] = "兑换机具";
                if (PosSnType == 1) dic["PosSnType"] = "循环机具";
                //设备类型
                string DeviceType = dic["DeviceType"].ToString();
                if (DeviceType == "KysSignPos") dic["DeviceType"] = "快益刷电签POS";
                if (DeviceType == "KssSignPos") dic["DeviceType"] = "快闪刷电签POS";
                if (DeviceType == "") dic["DeviceType"] = "";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("UserIdMakerCode", "创客编号");
            ReturnFields.Add("UserIdRealName", "创客姓名");
            ReturnFields.Add("BrandId", "产品类型");
            ReturnFields.Add("PosSn", "SN编号");
            ReturnFields.Add("PosSnType", "SN类型");
            ReturnFields.Add("ActivityList", "参加活动");
            ReturnFields.Add("BindMerchantIdMerchantNo", "绑定商户编号");
            ReturnFields.Add("BindMerchantIdMerchantName", "绑定商户姓名");
            ReturnFields.Add("DeviceType", "设备类型");
            ReturnFields.Add("BindingState", "绑定状态");
            ReturnFields.Add("ActivationState", "激活状态");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "PosMachines", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
